import{S as Br,i as Hr,s as zr,e as i,k as p,w as x,t,M as Rr,c as r,d as n,m as f,a as l,x as P,h as a,b as c,G as e,g as m,y,q as I,o as D,B as k,v as Wr,L as Vr}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as Ws}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as Ur}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as Zt}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Kr}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Jr(ea){let g,M,b,_,$;return _=new Ur({props:{code:`import PIL
import requests
import torch
from io import BytesIO

from diffusers import StableDiffusionInstructPix2PixPipeline


def download_image(url):
    response = requests.get(url)
    return PIL.Image.open(BytesIO(response.content)).convert("RGB")


img_url = "https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png"

image = download_image(img_url).resize((512, 512))

pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(
    "timbrooks/instruct-pix2pix", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

prompt = "make the mountains snowy"
image = pipe(prompt=prompt, image=image).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> PIL
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionInstructPix2PixPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
<span class="hljs-meta">... </span>    response = requests.get(url)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> PIL.Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>img_url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = download_image(img_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;timbrooks/instruct-pix2pix&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;make the mountains snowy&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(prompt=prompt, image=image).images[<span class="hljs-number">0</span>]`}}),{c(){g=i("p"),M=t("Examples:"),b=p(),x(_.$$.fragment)},l(h){g=r(h,"P",{});var C=l(g);M=a(C,"Examples:"),C.forEach(n),b=f(h),P(_.$$.fragment,h)},m(h,C){m(h,g,C),e(g,M),m(h,b,C),y(_,h,C),$=!0},p:Vr,i(h){$||(I(_.$$.fragment,h),$=!0)},o(h){D(_.$$.fragment,h),$=!1},d(h){h&&n(g),h&&n(b),k(_,h)}}}function Yr(ea){let g,M,b,_,$,h,C,Te,xa,ta,T,N,Oe,V,Pa,je,ya,aa,K,J,Ia,Da,na,_e,ka,oa,ve,Le,$a,sa,be,Ca,ia,w,we,Y,Sa,Ta,Oa,Ee,Q,ja,La,qa,xe,X,Aa,Ma,Na,Pe,Z,Fa,Ga,ra,O,F,qe,ee,Ua,Ae,Ba,la,G,Me,j,Ne,Ha,za,Fe,Ra,Wa,ye,Va,Ka,Ge,L,Ue,te,Ja,Ya,Be,He,Qa,Xa,Ie,ae,Za,da,q,U,ze,ne,en,Re,tn,ca,oe,pa,A,B,We,se,an,Ve,nn,fa,v,ie,on,Ke,sn,rn,re,ln,De,dn,cn,pn,E,le,fn,Je,un,mn,o,hn,Ye,gn,_n,Qe,vn,bn,Xe,wn,En,Ze,xn,Pn,et,yn,In,tt,Dn,kn,at,$n,Cn,de,Sn,Tn,nt,On,jn,ot,Ln,qn,ce,An,Mn,st,Nn,Fn,it,Gn,Un,rt,Bn,Hn,lt,zn,Rn,dt,Wn,Vn,ct,Kn,Jn,pt,Yn,Qn,ft,Xn,Zn,ut,eo,to,mt,ao,no,ht,oo,so,gt,io,ro,_t,lo,co,vt,po,fo,bt,uo,mo,wt,ho,go,Et,_o,vo,xt,bo,wo,Pt,Eo,xo,pe,Po,yo,ke,Io,Do,yt,ko,$o,It,Co,So,fe,To,Oo,Dt,jo,Lo,kt,qo,Ao,$t,Mo,No,Ct,Fo,Go,St,Uo,Bo,Tt,Ho,zo,Ot,Ro,Wo,jt,Vo,Ko,Lt,Jo,Yo,qt,Qo,Xo,At,Zo,es,Mt,ts,as,Nt,ns,os,Ft,ss,is,ue,rs,ls,Gt,ds,cs,Ut,ps,fs,Bt,us,ms,Ht,hs,gs,zt,_s,vs,$e,bs,ws,Rt,Es,xs,Wt,Ps,ys,Vt,Is,Ds,Kt,ks,$s,Jt,Cs,Ss,Yt,Ts,Os,Qt,js,Ls,qs,H,As,z,me,Ms,he,Ns,Xt,Fs,Gs,ua;return h=new Zt({}),V=new Zt({}),ee=new Zt({}),ne=new Zt({}),oe=new Ur({props:{code:`import PIL
import requests
import torch
from diffusers import StableDiffusionInstructPix2PixPipeline

model_id = "timbrooks/instruct-pix2pix"
pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

url = "https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png"


def download_image(url):
    image = PIL.Image.open(requests.get(url, stream=True).raw)
    image = PIL.ImageOps.exif_transpose(image)
    image = image.convert("RGB")
    return image


image = download_image(url)

prompt = "make the mountains snowy"
edit = pipe(prompt, image=image, num_inference_steps=20, image_guidance_scale=1.5, guidance_scale=7).images[0]
images[0].save("snowy_mountains.png")`,highlighted:`<span class="hljs-keyword">import</span> PIL
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionInstructPix2PixPipeline

model_id = <span class="hljs-string">&quot;timbrooks/instruct-pix2pix&quot;</span>
pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png&quot;</span>


<span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
    image = PIL.Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
    image = PIL.ImageOps.exif_transpose(image)
    image = image.convert(<span class="hljs-string">&quot;RGB&quot;</span>)
    <span class="hljs-keyword">return</span> image


image = download_image(url)

prompt = <span class="hljs-string">&quot;make the mountains snowy&quot;</span>
edit = pipe(prompt, image=image, num_inference_steps=<span class="hljs-number">20</span>, image_guidance_scale=<span class="hljs-number">1.5</span>, guidance_scale=<span class="hljs-number">7</span>).images[<span class="hljs-number">0</span>]
images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;snowy_mountains.png&quot;</span>)`}}),se=new Zt({}),ie=new Ws({props:{name:"class diffusers.StableDiffusionInstructPix2PixPipeline",anchor:"diffusers.StableDiffusionInstructPix2PixPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py#L57"}}),le=new Ws({props:{name:"__call__",anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"num_inference_steps",val:": int = 100"},{name:"guidance_scale",val:": float = 7.5"},{name:"image_guidance_scale",val:": float = 1.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py#L127",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),H=new Kr({props:{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.example",$$slots:{default:[Jr]},$$scope:{ctx:ea}}}),me=new Ws({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py#L383"}}),{c(){g=i("meta"),M=p(),b=i("h1"),_=i("a"),$=i("span"),x(h.$$.fragment),C=p(),Te=i("span"),xa=t("InstructPix2Pix: Learning to Follow Image Editing Instructions"),ta=p(),T=i("h2"),N=i("a"),Oe=i("span"),x(V.$$.fragment),Pa=p(),je=i("span"),ya=t("Overview"),aa=p(),K=i("p"),J=i("a"),Ia=t("InstructPix2Pix: Learning to Follow Image Editing Instructions"),Da=t(" by Tim Brooks, Aleksander Holynski and Alexei A. Efros."),na=p(),_e=i("p"),ka=t("The abstract of the paper is the following:"),oa=p(),ve=i("p"),Le=i("em"),$a=t("We propose a method for editing images from human instructions: given an input image and a written instruction that tells the model what to do, our model follows these instructions to edit the image. To obtain training data for this problem, we combine the knowledge of two large pretrained models \u2014 a language model (GPT-3) and a text-to-image model (Stable Diffusion) \u2014 to generate a large dataset of image editing examples. Our conditional diffusion model, InstructPix2Pix, is trained on our generated data, and generalizes to real images and user-written instructions at inference time. Since it performs edits in the forward pass and does not require per example fine-tuning or inversion, our model edits images quickly, in a matter of seconds. We show compelling editing results for a diverse collection of input images and written instructions."),sa=p(),be=i("p"),Ca=t("Resources:"),ia=p(),w=i("ul"),we=i("li"),Y=i("a"),Sa=t("Project Page"),Ta=t("."),Oa=p(),Ee=i("li"),Q=i("a"),ja=t("Paper"),La=t("."),qa=p(),xe=i("li"),X=i("a"),Aa=t("Original Code"),Ma=t("."),Na=p(),Pe=i("li"),Z=i("a"),Fa=t("Demo"),Ga=t("."),ra=p(),O=i("h2"),F=i("a"),qe=i("span"),x(ee.$$.fragment),Ua=p(),Ae=i("span"),Ba=t("Available Pipelines:"),la=p(),G=i("table"),Me=i("thead"),j=i("tr"),Ne=i("th"),Ha=t("Pipeline"),za=p(),Fe=i("th"),Ra=t("Tasks"),Wa=p(),ye=i("th"),Va=t("Demo"),Ka=p(),Ge=i("tbody"),L=i("tr"),Ue=i("td"),te=i("a"),Ja=t("StableDiffusionInstructPix2PixPipeline"),Ya=p(),Be=i("td"),He=i("em"),Qa=t("Text-Based Image Editing"),Xa=p(),Ie=i("td"),ae=i("a"),Za=t("\u{1F917} Space"),da=p(),q=i("h2"),U=i("a"),ze=i("span"),x(ne.$$.fragment),en=p(),Re=i("span"),tn=t("Usage example"),ca=p(),x(oe.$$.fragment),pa=p(),A=i("h2"),B=i("a"),We=i("span"),x(se.$$.fragment),an=p(),Ve=i("span"),nn=t("StableDiffusionInstructPix2PixPipeline"),fa=p(),v=i("div"),x(ie.$$.fragment),on=p(),Ke=i("p"),sn=t("Pipeline for pixel-level image editing by following text instructions. Based on Stable Diffusion."),rn=p(),re=i("p"),ln=t("This model inherits from "),De=i("a"),dn=t("DiffusionPipeline"),cn=t(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),pn=p(),E=i("div"),x(le.$$.fragment),fn=p(),Je=i("p"),un=t("Function invoked when calling the pipeline for generation."),mn=p(),o=i("p"),hn=t("image ("),Ye=i("code"),gn=t("PIL.Image.Image"),_n=t(`):
`),Qe=i("code"),vn=t("Image"),bn=t(", or tensor representing an image batch which will be repainted according to "),Xe=i("code"),wn=t("prompt"),En=t(`.
num_inference_steps (`),Ze=i("code"),xn=t("int"),Pn=t(", "),et=i("em"),yn=t("optional"),In=t(`, defaults to 100):
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.
guidance_scale (`),tt=i("code"),Dn=t("float"),kn=t(", "),at=i("em"),$n=t("optional"),Cn=t(`, defaults to 7.5):
Guidance scale as defined in `),de=i("a"),Sn=t("Classifier-Free Diffusion Guidance"),Tn=t(`.
`),nt=i("code"),On=t("guidance_scale"),jn=t(" is defined as "),ot=i("code"),Ln=t("w"),qn=t(" of equation 2. of "),ce=i("a"),An=t(`Imagen
Paper`),Mn=t(". Guidance scale is enabled by setting "),st=i("code"),Nn=t("guidance_scale > 1"),Fn=t(". Higher guidance scale encourages to generate images that are closely linked to the text "),it=i("code"),Gn=t("prompt"),Un=t(`,
usually at the expense of lower image quality. This pipeline requires a value of at least `),rt=i("code"),Bn=t("1"),Hn=t(`.
image_guidance_scale (`),lt=i("code"),zn=t("float"),Rn=t(", "),dt=i("em"),Wn=t("optional"),Vn=t(`, defaults to 1.5):
Image guidance scale is to push the generated image towards the inital image `),ct=i("code"),Kn=t("image"),Jn=t(`. Image guidance
scale is enabled by setting `),pt=i("code"),Yn=t("image_guidance_scale > 1"),Qn=t(`. Higher image guidance scale encourages to
generate images that are closely linked to the source image `),ft=i("code"),Xn=t("image"),Zn=t(`, usually at the expense of lower
image quality. This pipeline requires a value of at least `),ut=i("code"),eo=t("1"),to=t(`.
negative_prompt (`),mt=i("code"),ao=t("str"),no=t(" or "),ht=i("code"),oo=t("List[str]"),so=t(", "),gt=i("em"),io=t("optional"),ro=t(`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),_t=i("code"),lo=t("negative_prompt_embeds"),co=t(". instead. Ignored when not using guidance (i.e., ignored if "),vt=i("code"),po=t("guidance_scale"),fo=t(`
is less than `),bt=i("code"),uo=t("1"),mo=t(`).
num_images_per_prompt (`),wt=i("code"),ho=t("int"),go=t(", "),Et=i("em"),_o=t("optional"),vo=t(`, defaults to 1):
The number of images to generate per prompt.
eta (`),xt=i("code"),bo=t("float"),wo=t(", "),Pt=i("em"),Eo=t("optional"),xo=t(`, defaults to 0.0):
Corresponds to parameter eta (\u03B7) in the DDIM paper: `),pe=i("a"),Po=t("https://arxiv.org/abs/2010.02502"),yo=t(`. Only applies to
`),ke=i("a"),Io=t("schedulers.DDIMScheduler"),Do=t(`, will be ignored for others.
generator (`),yt=i("code"),ko=t("torch.Generator"),$o=t(", "),It=i("em"),Co=t("optional"),So=t(`):
One or a list of `),fe=i("a"),To=t("torch generator(s)"),Oo=t(`
to make generation deterministic.
latents (`),Dt=i("code"),jo=t("torch.FloatTensor"),Lo=t(", "),kt=i("em"),qo=t("optional"),Ao=t(`):
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random `),$t=i("code"),Mo=t("generator"),No=t(`.
prompt_embeds (`),Ct=i("code"),Fo=t("torch.FloatTensor"),Go=t(", "),St=i("em"),Uo=t("optional"),Bo=t(`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Tt=i("em"),Ho=t("e.g."),zo=t(` prompt weighting. If not
provided, text embeddings will be generated from `),Ot=i("code"),Ro=t("prompt"),Wo=t(` input argument.
negative_prompt_embeds (`),jt=i("code"),Vo=t("torch.FloatTensor"),Ko=t(", "),Lt=i("em"),Jo=t("optional"),Yo=t(`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),qt=i("em"),Qo=t("e.g."),Xo=t(` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),At=i("code"),Zo=t("negative_prompt"),es=t(` input
argument.
output_type (`),Mt=i("code"),ts=t("str"),as=t(", "),Nt=i("em"),ns=t("optional"),os=t(", defaults to "),Ft=i("code"),ss=t('"pil"'),is=t(`):
The output format of the generate image. Choose between
`),ue=i("a"),rs=t("PIL"),ls=t(": "),Gt=i("code"),ds=t("PIL.Image.Image"),cs=t(" or "),Ut=i("code"),ps=t("np.array"),fs=t(`.
return_dict (`),Bt=i("code"),us=t("bool"),ms=t(", "),Ht=i("em"),hs=t("optional"),gs=t(", defaults to "),zt=i("code"),_s=t("True"),vs=t(`):
Whether or not to return a `),$e=i("a"),bs=t("StableDiffusionPipelineOutput"),ws=t(` instead of a
plain tuple.
callback (`),Rt=i("code"),Es=t("Callable"),xs=t(", "),Wt=i("em"),Ps=t("optional"),ys=t(`):
A function that will be called every `),Vt=i("code"),Is=t("callback_steps"),Ds=t(` steps during inference. The function will be
called with the following arguments: `),Kt=i("code"),ks=t("callback(step: int, timestep: int, latents: torch.FloatTensor)"),$s=t(`.
callback_steps (`),Jt=i("code"),Cs=t("int"),Ss=t(", "),Yt=i("em"),Ts=t("optional"),Os=t(`, defaults to 1):
The frequency at which the `),Qt=i("code"),js=t("callback"),Ls=t(` function will be called. If not specified, the callback will be
called at every step.`),qs=p(),x(H.$$.fragment),As=p(),z=i("div"),x(me.$$.fragment),Ms=p(),he=i("p"),Ns=t(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Xt=i("code"),Fs=t("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Gs=t("forward` method called."),this.h()},l(d){const u=Rr('[data-svelte="svelte-1phssyn"]',document.head);g=r(u,"META",{name:!0,content:!0}),u.forEach(n),M=f(d),b=r(d,"H1",{class:!0});var ge=l(b);_=r(ge,"A",{id:!0,class:!0,href:!0});var Vs=l(_);$=r(Vs,"SPAN",{});var Ks=l($);P(h.$$.fragment,Ks),Ks.forEach(n),Vs.forEach(n),C=f(ge),Te=r(ge,"SPAN",{});var Js=l(Te);xa=a(Js,"InstructPix2Pix: Learning to Follow Image Editing Instructions"),Js.forEach(n),ge.forEach(n),ta=f(d),T=r(d,"H2",{class:!0});var ma=l(T);N=r(ma,"A",{id:!0,class:!0,href:!0});var Ys=l(N);Oe=r(Ys,"SPAN",{});var Qs=l(Oe);P(V.$$.fragment,Qs),Qs.forEach(n),Ys.forEach(n),Pa=f(ma),je=r(ma,"SPAN",{});var Xs=l(je);ya=a(Xs,"Overview"),Xs.forEach(n),ma.forEach(n),aa=f(d),K=r(d,"P",{});var Us=l(K);J=r(Us,"A",{href:!0,rel:!0});var Zs=l(J);Ia=a(Zs,"InstructPix2Pix: Learning to Follow Image Editing Instructions"),Zs.forEach(n),Da=a(Us," by Tim Brooks, Aleksander Holynski and Alexei A. Efros."),Us.forEach(n),na=f(d),_e=r(d,"P",{});var ei=l(_e);ka=a(ei,"The abstract of the paper is the following:"),ei.forEach(n),oa=f(d),ve=r(d,"P",{});var ti=l(ve);Le=r(ti,"EM",{});var ai=l(Le);$a=a(ai,"We propose a method for editing images from human instructions: given an input image and a written instruction that tells the model what to do, our model follows these instructions to edit the image. To obtain training data for this problem, we combine the knowledge of two large pretrained models \u2014 a language model (GPT-3) and a text-to-image model (Stable Diffusion) \u2014 to generate a large dataset of image editing examples. Our conditional diffusion model, InstructPix2Pix, is trained on our generated data, and generalizes to real images and user-written instructions at inference time. Since it performs edits in the forward pass and does not require per example fine-tuning or inversion, our model edits images quickly, in a matter of seconds. We show compelling editing results for a diverse collection of input images and written instructions."),ai.forEach(n),ti.forEach(n),sa=f(d),be=r(d,"P",{});var ni=l(be);Ca=a(ni,"Resources:"),ni.forEach(n),ia=f(d),w=r(d,"UL",{});var R=l(w);we=r(R,"LI",{});var Bs=l(we);Y=r(Bs,"A",{href:!0,rel:!0});var oi=l(Y);Sa=a(oi,"Project Page"),oi.forEach(n),Ta=a(Bs,"."),Bs.forEach(n),Oa=f(R),Ee=r(R,"LI",{});var Hs=l(Ee);Q=r(Hs,"A",{href:!0,rel:!0});var si=l(Q);ja=a(si,"Paper"),si.forEach(n),La=a(Hs,"."),Hs.forEach(n),qa=f(R),xe=r(R,"LI",{});var zs=l(xe);X=r(zs,"A",{href:!0,rel:!0});var ii=l(X);Aa=a(ii,"Original Code"),ii.forEach(n),Ma=a(zs,"."),zs.forEach(n),Na=f(R),Pe=r(R,"LI",{});var Rs=l(Pe);Z=r(Rs,"A",{href:!0,rel:!0});var ri=l(Z);Fa=a(ri,"Demo"),ri.forEach(n),Ga=a(Rs,"."),Rs.forEach(n),R.forEach(n),ra=f(d),O=r(d,"H2",{class:!0});var ha=l(O);F=r(ha,"A",{id:!0,class:!0,href:!0});var li=l(F);qe=r(li,"SPAN",{});var di=l(qe);P(ee.$$.fragment,di),di.forEach(n),li.forEach(n),Ua=f(ha),Ae=r(ha,"SPAN",{});var ci=l(Ae);Ba=a(ci,"Available Pipelines:"),ci.forEach(n),ha.forEach(n),la=f(d),G=r(d,"TABLE",{});var ga=l(G);Me=r(ga,"THEAD",{});var pi=l(Me);j=r(pi,"TR",{});var Ce=l(j);Ne=r(Ce,"TH",{});var fi=l(Ne);Ha=a(fi,"Pipeline"),fi.forEach(n),za=f(Ce),Fe=r(Ce,"TH",{});var ui=l(Fe);Ra=a(ui,"Tasks"),ui.forEach(n),Wa=f(Ce),ye=r(Ce,"TH",{align:!0});var mi=l(ye);Va=a(mi,"Demo"),mi.forEach(n),Ce.forEach(n),pi.forEach(n),Ka=f(ga),Ge=r(ga,"TBODY",{});var hi=l(Ge);L=r(hi,"TR",{});var Se=l(L);Ue=r(Se,"TD",{});var gi=l(Ue);te=r(gi,"A",{href:!0,rel:!0});var _i=l(te);Ja=a(_i,"StableDiffusionInstructPix2PixPipeline"),_i.forEach(n),gi.forEach(n),Ya=f(Se),Be=r(Se,"TD",{});var vi=l(Be);He=r(vi,"EM",{});var bi=l(He);Qa=a(bi,"Text-Based Image Editing"),bi.forEach(n),vi.forEach(n),Xa=f(Se),Ie=r(Se,"TD",{align:!0});var wi=l(Ie);ae=r(wi,"A",{href:!0,rel:!0});var Ei=l(ae);Za=a(Ei,"\u{1F917} Space"),Ei.forEach(n),wi.forEach(n),Se.forEach(n),hi.forEach(n),ga.forEach(n),da=f(d),q=r(d,"H2",{class:!0});var _a=l(q);U=r(_a,"A",{id:!0,class:!0,href:!0});var xi=l(U);ze=r(xi,"SPAN",{});var Pi=l(ze);P(ne.$$.fragment,Pi),Pi.forEach(n),xi.forEach(n),en=f(_a),Re=r(_a,"SPAN",{});var yi=l(Re);tn=a(yi,"Usage example"),yi.forEach(n),_a.forEach(n),ca=f(d),P(oe.$$.fragment,d),pa=f(d),A=r(d,"H2",{class:!0});var va=l(A);B=r(va,"A",{id:!0,class:!0,href:!0});var Ii=l(B);We=r(Ii,"SPAN",{});var Di=l(We);P(se.$$.fragment,Di),Di.forEach(n),Ii.forEach(n),an=f(va),Ve=r(va,"SPAN",{});var ki=l(Ve);nn=a(ki,"StableDiffusionInstructPix2PixPipeline"),ki.forEach(n),va.forEach(n),fa=f(d),v=r(d,"DIV",{class:!0});var S=l(v);P(ie.$$.fragment,S),on=f(S),Ke=r(S,"P",{});var $i=l(Ke);sn=a($i,"Pipeline for pixel-level image editing by following text instructions. Based on Stable Diffusion."),$i.forEach(n),rn=f(S),re=r(S,"P",{});var ba=l(re);ln=a(ba,"This model inherits from "),De=r(ba,"A",{href:!0});var Ci=l(De);dn=a(Ci,"DiffusionPipeline"),Ci.forEach(n),cn=a(ba,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ba.forEach(n),pn=f(S),E=r(S,"DIV",{class:!0});var W=l(E);P(le.$$.fragment,W),fn=f(W),Je=r(W,"P",{});var Si=l(Je);un=a(Si,"Function invoked when calling the pipeline for generation."),Si.forEach(n),mn=f(W),o=r(W,"P",{});var s=l(o);hn=a(s,"image ("),Ye=r(s,"CODE",{});var Ti=l(Ye);gn=a(Ti,"PIL.Image.Image"),Ti.forEach(n),_n=a(s,`):
`),Qe=r(s,"CODE",{});var Oi=l(Qe);vn=a(Oi,"Image"),Oi.forEach(n),bn=a(s,", or tensor representing an image batch which will be repainted according to "),Xe=r(s,"CODE",{});var ji=l(Xe);wn=a(ji,"prompt"),ji.forEach(n),En=a(s,`.
num_inference_steps (`),Ze=r(s,"CODE",{});var Li=l(Ze);xn=a(Li,"int"),Li.forEach(n),Pn=a(s,", "),et=r(s,"EM",{});var qi=l(et);yn=a(qi,"optional"),qi.forEach(n),In=a(s,`, defaults to 100):
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.
guidance_scale (`),tt=r(s,"CODE",{});var Ai=l(tt);Dn=a(Ai,"float"),Ai.forEach(n),kn=a(s,", "),at=r(s,"EM",{});var Mi=l(at);$n=a(Mi,"optional"),Mi.forEach(n),Cn=a(s,`, defaults to 7.5):
Guidance scale as defined in `),de=r(s,"A",{href:!0,rel:!0});var Ni=l(de);Sn=a(Ni,"Classifier-Free Diffusion Guidance"),Ni.forEach(n),Tn=a(s,`.
`),nt=r(s,"CODE",{});var Fi=l(nt);On=a(Fi,"guidance_scale"),Fi.forEach(n),jn=a(s," is defined as "),ot=r(s,"CODE",{});var Gi=l(ot);Ln=a(Gi,"w"),Gi.forEach(n),qn=a(s," of equation 2. of "),ce=r(s,"A",{href:!0,rel:!0});var Ui=l(ce);An=a(Ui,`Imagen
Paper`),Ui.forEach(n),Mn=a(s,". Guidance scale is enabled by setting "),st=r(s,"CODE",{});var Bi=l(st);Nn=a(Bi,"guidance_scale > 1"),Bi.forEach(n),Fn=a(s,". Higher guidance scale encourages to generate images that are closely linked to the text "),it=r(s,"CODE",{});var Hi=l(it);Gn=a(Hi,"prompt"),Hi.forEach(n),Un=a(s,`,
usually at the expense of lower image quality. This pipeline requires a value of at least `),rt=r(s,"CODE",{});var zi=l(rt);Bn=a(zi,"1"),zi.forEach(n),Hn=a(s,`.
image_guidance_scale (`),lt=r(s,"CODE",{});var Ri=l(lt);zn=a(Ri,"float"),Ri.forEach(n),Rn=a(s,", "),dt=r(s,"EM",{});var Wi=l(dt);Wn=a(Wi,"optional"),Wi.forEach(n),Vn=a(s,`, defaults to 1.5):
Image guidance scale is to push the generated image towards the inital image `),ct=r(s,"CODE",{});var Vi=l(ct);Kn=a(Vi,"image"),Vi.forEach(n),Jn=a(s,`. Image guidance
scale is enabled by setting `),pt=r(s,"CODE",{});var Ki=l(pt);Yn=a(Ki,"image_guidance_scale > 1"),Ki.forEach(n),Qn=a(s,`. Higher image guidance scale encourages to
generate images that are closely linked to the source image `),ft=r(s,"CODE",{});var Ji=l(ft);Xn=a(Ji,"image"),Ji.forEach(n),Zn=a(s,`, usually at the expense of lower
image quality. This pipeline requires a value of at least `),ut=r(s,"CODE",{});var Yi=l(ut);eo=a(Yi,"1"),Yi.forEach(n),to=a(s,`.
negative_prompt (`),mt=r(s,"CODE",{});var Qi=l(mt);ao=a(Qi,"str"),Qi.forEach(n),no=a(s," or "),ht=r(s,"CODE",{});var Xi=l(ht);oo=a(Xi,"List[str]"),Xi.forEach(n),so=a(s,", "),gt=r(s,"EM",{});var Zi=l(gt);io=a(Zi,"optional"),Zi.forEach(n),ro=a(s,`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),_t=r(s,"CODE",{});var er=l(_t);lo=a(er,"negative_prompt_embeds"),er.forEach(n),co=a(s,". instead. Ignored when not using guidance (i.e., ignored if "),vt=r(s,"CODE",{});var tr=l(vt);po=a(tr,"guidance_scale"),tr.forEach(n),fo=a(s,`
is less than `),bt=r(s,"CODE",{});var ar=l(bt);uo=a(ar,"1"),ar.forEach(n),mo=a(s,`).
num_images_per_prompt (`),wt=r(s,"CODE",{});var nr=l(wt);ho=a(nr,"int"),nr.forEach(n),go=a(s,", "),Et=r(s,"EM",{});var or=l(Et);_o=a(or,"optional"),or.forEach(n),vo=a(s,`, defaults to 1):
The number of images to generate per prompt.
eta (`),xt=r(s,"CODE",{});var sr=l(xt);bo=a(sr,"float"),sr.forEach(n),wo=a(s,", "),Pt=r(s,"EM",{});var ir=l(Pt);Eo=a(ir,"optional"),ir.forEach(n),xo=a(s,`, defaults to 0.0):
Corresponds to parameter eta (\u03B7) in the DDIM paper: `),pe=r(s,"A",{href:!0,rel:!0});var rr=l(pe);Po=a(rr,"https://arxiv.org/abs/2010.02502"),rr.forEach(n),yo=a(s,`. Only applies to
`),ke=r(s,"A",{href:!0});var lr=l(ke);Io=a(lr,"schedulers.DDIMScheduler"),lr.forEach(n),Do=a(s,`, will be ignored for others.
generator (`),yt=r(s,"CODE",{});var dr=l(yt);ko=a(dr,"torch.Generator"),dr.forEach(n),$o=a(s,", "),It=r(s,"EM",{});var cr=l(It);Co=a(cr,"optional"),cr.forEach(n),So=a(s,`):
One or a list of `),fe=r(s,"A",{href:!0,rel:!0});var pr=l(fe);To=a(pr,"torch generator(s)"),pr.forEach(n),Oo=a(s,`
to make generation deterministic.
latents (`),Dt=r(s,"CODE",{});var fr=l(Dt);jo=a(fr,"torch.FloatTensor"),fr.forEach(n),Lo=a(s,", "),kt=r(s,"EM",{});var ur=l(kt);qo=a(ur,"optional"),ur.forEach(n),Ao=a(s,`):
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random `),$t=r(s,"CODE",{});var mr=l($t);Mo=a(mr,"generator"),mr.forEach(n),No=a(s,`.
prompt_embeds (`),Ct=r(s,"CODE",{});var hr=l(Ct);Fo=a(hr,"torch.FloatTensor"),hr.forEach(n),Go=a(s,", "),St=r(s,"EM",{});var gr=l(St);Uo=a(gr,"optional"),gr.forEach(n),Bo=a(s,`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Tt=r(s,"EM",{});var _r=l(Tt);Ho=a(_r,"e.g."),_r.forEach(n),zo=a(s,` prompt weighting. If not
provided, text embeddings will be generated from `),Ot=r(s,"CODE",{});var vr=l(Ot);Ro=a(vr,"prompt"),vr.forEach(n),Wo=a(s,` input argument.
negative_prompt_embeds (`),jt=r(s,"CODE",{});var br=l(jt);Vo=a(br,"torch.FloatTensor"),br.forEach(n),Ko=a(s,", "),Lt=r(s,"EM",{});var wr=l(Lt);Jo=a(wr,"optional"),wr.forEach(n),Yo=a(s,`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),qt=r(s,"EM",{});var Er=l(qt);Qo=a(Er,"e.g."),Er.forEach(n),Xo=a(s,` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),At=r(s,"CODE",{});var xr=l(At);Zo=a(xr,"negative_prompt"),xr.forEach(n),es=a(s,` input
argument.
output_type (`),Mt=r(s,"CODE",{});var Pr=l(Mt);ts=a(Pr,"str"),Pr.forEach(n),as=a(s,", "),Nt=r(s,"EM",{});var yr=l(Nt);ns=a(yr,"optional"),yr.forEach(n),os=a(s,", defaults to "),Ft=r(s,"CODE",{});var Ir=l(Ft);ss=a(Ir,'"pil"'),Ir.forEach(n),is=a(s,`):
The output format of the generate image. Choose between
`),ue=r(s,"A",{href:!0,rel:!0});var Dr=l(ue);rs=a(Dr,"PIL"),Dr.forEach(n),ls=a(s,": "),Gt=r(s,"CODE",{});var kr=l(Gt);ds=a(kr,"PIL.Image.Image"),kr.forEach(n),cs=a(s," or "),Ut=r(s,"CODE",{});var $r=l(Ut);ps=a($r,"np.array"),$r.forEach(n),fs=a(s,`.
return_dict (`),Bt=r(s,"CODE",{});var Cr=l(Bt);us=a(Cr,"bool"),Cr.forEach(n),ms=a(s,", "),Ht=r(s,"EM",{});var Sr=l(Ht);hs=a(Sr,"optional"),Sr.forEach(n),gs=a(s,", defaults to "),zt=r(s,"CODE",{});var Tr=l(zt);_s=a(Tr,"True"),Tr.forEach(n),vs=a(s,`):
Whether or not to return a `),$e=r(s,"A",{href:!0});var Or=l($e);bs=a(Or,"StableDiffusionPipelineOutput"),Or.forEach(n),ws=a(s,` instead of a
plain tuple.
callback (`),Rt=r(s,"CODE",{});var jr=l(Rt);Es=a(jr,"Callable"),jr.forEach(n),xs=a(s,", "),Wt=r(s,"EM",{});var Lr=l(Wt);Ps=a(Lr,"optional"),Lr.forEach(n),ys=a(s,`):
A function that will be called every `),Vt=r(s,"CODE",{});var qr=l(Vt);Is=a(qr,"callback_steps"),qr.forEach(n),Ds=a(s,` steps during inference. The function will be
called with the following arguments: `),Kt=r(s,"CODE",{});var Ar=l(Kt);ks=a(Ar,"callback(step: int, timestep: int, latents: torch.FloatTensor)"),Ar.forEach(n),$s=a(s,`.
callback_steps (`),Jt=r(s,"CODE",{});var Mr=l(Jt);Cs=a(Mr,"int"),Mr.forEach(n),Ss=a(s,", "),Yt=r(s,"EM",{});var Nr=l(Yt);Ts=a(Nr,"optional"),Nr.forEach(n),Os=a(s,`, defaults to 1):
The frequency at which the `),Qt=r(s,"CODE",{});var Fr=l(Qt);js=a(Fr,"callback"),Fr.forEach(n),Ls=a(s,` function will be called. If not specified, the callback will be
called at every step.`),s.forEach(n),qs=f(W),P(H.$$.fragment,W),W.forEach(n),As=f(S),z=r(S,"DIV",{class:!0});var wa=l(z);P(me.$$.fragment,wa),Ms=f(wa),he=r(wa,"P",{});var Ea=l(he);Ns=a(Ea,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Xt=r(Ea,"CODE",{});var Gr=l(Xt);Fs=a(Gr,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Gr.forEach(n),Gs=a(Ea,"forward` method called."),Ea.forEach(n),wa.forEach(n),S.forEach(n),this.h()},h(){c(g,"name","hf:doc:metadata"),c(g,"content",JSON.stringify(Qr)),c(_,"id","instructpix2pix-learning-to-follow-image-editing-instructions"),c(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(_,"href","#instructpix2pix-learning-to-follow-image-editing-instructions"),c(b,"class","relative group"),c(N,"id","overview"),c(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(N,"href","#overview"),c(T,"class","relative group"),c(J,"href","https://arxiv.org/abs/2211.09800"),c(J,"rel","nofollow"),c(Y,"href","https://www.timothybrooks.com/instruct-pix2pix"),c(Y,"rel","nofollow"),c(Q,"href","https://arxiv.org/abs/2211.09800"),c(Q,"rel","nofollow"),c(X,"href","https://github.com/timothybrooks/instruct-pix2pix"),c(X,"rel","nofollow"),c(Z,"href","https://huggingface.co/spaces/timbrooks/instruct-pix2pix"),c(Z,"rel","nofollow"),c(F,"id","available-pipelines"),c(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(F,"href","#available-pipelines"),c(O,"class","relative group"),c(ye,"align","center"),c(te,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py"),c(te,"rel","nofollow"),c(ae,"href","https://huggingface.co/spaces/timbrooks/instruct-pix2pix"),c(ae,"rel","nofollow"),c(Ie,"align","center"),c(U,"id","usage-example"),c(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(U,"href","#usage-example"),c(q,"class","relative group"),c(B,"id","diffusers.StableDiffusionInstructPix2PixPipeline"),c(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(B,"href","#diffusers.StableDiffusionInstructPix2PixPipeline"),c(A,"class","relative group"),c(De,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(de,"href","https://arxiv.org/abs/2207.12598"),c(de,"rel","nofollow"),c(ce,"href","https://arxiv.org/pdf/2205.11487.pdf"),c(ce,"rel","nofollow"),c(pe,"href","https://arxiv.org/abs/2010.02502"),c(pe,"rel","nofollow"),c(ke,"href","/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler"),c(fe,"href","https://pytorch.org/docs/stable/generated/torch.Generator.html"),c(fe,"rel","nofollow"),c(ue,"href","https://pillow.readthedocs.io/en/stable/"),c(ue,"rel","nofollow"),c($e,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"),c(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(d,u){e(document.head,g),m(d,M,u),m(d,b,u),e(b,_),e(_,$),y(h,$,null),e(b,C),e(b,Te),e(Te,xa),m(d,ta,u),m(d,T,u),e(T,N),e(N,Oe),y(V,Oe,null),e(T,Pa),e(T,je),e(je,ya),m(d,aa,u),m(d,K,u),e(K,J),e(J,Ia),e(K,Da),m(d,na,u),m(d,_e,u),e(_e,ka),m(d,oa,u),m(d,ve,u),e(ve,Le),e(Le,$a),m(d,sa,u),m(d,be,u),e(be,Ca),m(d,ia,u),m(d,w,u),e(w,we),e(we,Y),e(Y,Sa),e(we,Ta),e(w,Oa),e(w,Ee),e(Ee,Q),e(Q,ja),e(Ee,La),e(w,qa),e(w,xe),e(xe,X),e(X,Aa),e(xe,Ma),e(w,Na),e(w,Pe),e(Pe,Z),e(Z,Fa),e(Pe,Ga),m(d,ra,u),m(d,O,u),e(O,F),e(F,qe),y(ee,qe,null),e(O,Ua),e(O,Ae),e(Ae,Ba),m(d,la,u),m(d,G,u),e(G,Me),e(Me,j),e(j,Ne),e(Ne,Ha),e(j,za),e(j,Fe),e(Fe,Ra),e(j,Wa),e(j,ye),e(ye,Va),e(G,Ka),e(G,Ge),e(Ge,L),e(L,Ue),e(Ue,te),e(te,Ja),e(L,Ya),e(L,Be),e(Be,He),e(He,Qa),e(L,Xa),e(L,Ie),e(Ie,ae),e(ae,Za),m(d,da,u),m(d,q,u),e(q,U),e(U,ze),y(ne,ze,null),e(q,en),e(q,Re),e(Re,tn),m(d,ca,u),y(oe,d,u),m(d,pa,u),m(d,A,u),e(A,B),e(B,We),y(se,We,null),e(A,an),e(A,Ve),e(Ve,nn),m(d,fa,u),m(d,v,u),y(ie,v,null),e(v,on),e(v,Ke),e(Ke,sn),e(v,rn),e(v,re),e(re,ln),e(re,De),e(De,dn),e(re,cn),e(v,pn),e(v,E),y(le,E,null),e(E,fn),e(E,Je),e(Je,un),e(E,mn),e(E,o),e(o,hn),e(o,Ye),e(Ye,gn),e(o,_n),e(o,Qe),e(Qe,vn),e(o,bn),e(o,Xe),e(Xe,wn),e(o,En),e(o,Ze),e(Ze,xn),e(o,Pn),e(o,et),e(et,yn),e(o,In),e(o,tt),e(tt,Dn),e(o,kn),e(o,at),e(at,$n),e(o,Cn),e(o,de),e(de,Sn),e(o,Tn),e(o,nt),e(nt,On),e(o,jn),e(o,ot),e(ot,Ln),e(o,qn),e(o,ce),e(ce,An),e(o,Mn),e(o,st),e(st,Nn),e(o,Fn),e(o,it),e(it,Gn),e(o,Un),e(o,rt),e(rt,Bn),e(o,Hn),e(o,lt),e(lt,zn),e(o,Rn),e(o,dt),e(dt,Wn),e(o,Vn),e(o,ct),e(ct,Kn),e(o,Jn),e(o,pt),e(pt,Yn),e(o,Qn),e(o,ft),e(ft,Xn),e(o,Zn),e(o,ut),e(ut,eo),e(o,to),e(o,mt),e(mt,ao),e(o,no),e(o,ht),e(ht,oo),e(o,so),e(o,gt),e(gt,io),e(o,ro),e(o,_t),e(_t,lo),e(o,co),e(o,vt),e(vt,po),e(o,fo),e(o,bt),e(bt,uo),e(o,mo),e(o,wt),e(wt,ho),e(o,go),e(o,Et),e(Et,_o),e(o,vo),e(o,xt),e(xt,bo),e(o,wo),e(o,Pt),e(Pt,Eo),e(o,xo),e(o,pe),e(pe,Po),e(o,yo),e(o,ke),e(ke,Io),e(o,Do),e(o,yt),e(yt,ko),e(o,$o),e(o,It),e(It,Co),e(o,So),e(o,fe),e(fe,To),e(o,Oo),e(o,Dt),e(Dt,jo),e(o,Lo),e(o,kt),e(kt,qo),e(o,Ao),e(o,$t),e($t,Mo),e(o,No),e(o,Ct),e(Ct,Fo),e(o,Go),e(o,St),e(St,Uo),e(o,Bo),e(o,Tt),e(Tt,Ho),e(o,zo),e(o,Ot),e(Ot,Ro),e(o,Wo),e(o,jt),e(jt,Vo),e(o,Ko),e(o,Lt),e(Lt,Jo),e(o,Yo),e(o,qt),e(qt,Qo),e(o,Xo),e(o,At),e(At,Zo),e(o,es),e(o,Mt),e(Mt,ts),e(o,as),e(o,Nt),e(Nt,ns),e(o,os),e(o,Ft),e(Ft,ss),e(o,is),e(o,ue),e(ue,rs),e(o,ls),e(o,Gt),e(Gt,ds),e(o,cs),e(o,Ut),e(Ut,ps),e(o,fs),e(o,Bt),e(Bt,us),e(o,ms),e(o,Ht),e(Ht,hs),e(o,gs),e(o,zt),e(zt,_s),e(o,vs),e(o,$e),e($e,bs),e(o,ws),e(o,Rt),e(Rt,Es),e(o,xs),e(o,Wt),e(Wt,Ps),e(o,ys),e(o,Vt),e(Vt,Is),e(o,Ds),e(o,Kt),e(Kt,ks),e(o,$s),e(o,Jt),e(Jt,Cs),e(o,Ss),e(o,Yt),e(Yt,Ts),e(o,Os),e(o,Qt),e(Qt,js),e(o,Ls),e(E,qs),y(H,E,null),e(v,As),e(v,z),y(me,z,null),e(z,Ms),e(z,he),e(he,Ns),e(he,Xt),e(Xt,Fs),e(he,Gs),ua=!0},p(d,[u]){const ge={};u&2&&(ge.$$scope={dirty:u,ctx:d}),H.$set(ge)},i(d){ua||(I(h.$$.fragment,d),I(V.$$.fragment,d),I(ee.$$.fragment,d),I(ne.$$.fragment,d),I(oe.$$.fragment,d),I(se.$$.fragment,d),I(ie.$$.fragment,d),I(le.$$.fragment,d),I(H.$$.fragment,d),I(me.$$.fragment,d),ua=!0)},o(d){D(h.$$.fragment,d),D(V.$$.fragment,d),D(ee.$$.fragment,d),D(ne.$$.fragment,d),D(oe.$$.fragment,d),D(se.$$.fragment,d),D(ie.$$.fragment,d),D(le.$$.fragment,d),D(H.$$.fragment,d),D(me.$$.fragment,d),ua=!1},d(d){n(g),d&&n(M),d&&n(b),k(h),d&&n(ta),d&&n(T),k(V),d&&n(aa),d&&n(K),d&&n(na),d&&n(_e),d&&n(oa),d&&n(ve),d&&n(sa),d&&n(be),d&&n(ia),d&&n(w),d&&n(ra),d&&n(O),k(ee),d&&n(la),d&&n(G),d&&n(da),d&&n(q),k(ne),d&&n(ca),k(oe,d),d&&n(pa),d&&n(A),k(se),d&&n(fa),d&&n(v),k(ie),k(le),k(H),k(me)}}}const Qr={local:"instructpix2pix-learning-to-follow-image-editing-instructions",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"diffusers.StableDiffusionInstructPix2PixPipeline",title:"StableDiffusionInstructPix2PixPipeline"}],title:"InstructPix2Pix: Learning to Follow Image Editing Instructions"};function Xr(ea){return Wr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ol extends Br{constructor(g){super();Hr(this,g,Xr,Yr,zr,{})}}export{ol as default,Qr as metadata};
